/*
  Примеры для книги Белова Александра
  Программа 6.2.   Глава 6
  Программный антидребезг с использованием внешней библиотеки

 Переключение светодиода (LED), подключенного к цифровому контакту 8, 
 при каждом нажатии на кнопку, подключенную к контакту 2 светодиод переключается (горит/не горит).
 с использованием программного антидребезга

 Схема:
 * Последовательное соединение светодиода и резистора 270 Ом подключается между выводом 8 и контактом +5 В
 * Кнопка подключается между контактом 2 и общим  проводом
 */

#include <Button.h>

// Постоянные константы. В данной программе
// константы определяют номера используемых контактов:
const int buttonPin = 2;       // номер контакта для подключения кнопки
const int ledPin = 13;         // номер контакта для подключения светодиода
const int DelayTime = 20;      // Задержка антидребезга

// Создание объекта "кнопка"
Button button1 (buttonPin, DelayTime); 

void setup() {
  // инициализируем контакт светодиода на вывод:
  pinMode(ledPin, OUTPUT);
  // инициализируем контакт кнопки на ввод:
  pinMode(buttonPin, INPUT_PULLUP);
  digitalWrite(ledPin, LOW);
}

void loop() {
  // вызов метода ожидания стабильного состояния для кнопки
  button1.scanState();  
  if ( button1.flagClick == true ) {
    button1.flagClick = false;  // сброс признака клика кнопки
    // Переключение светодиода:
    digitalWrite(ledPin, !digitalRead(ledPin)); 
  }
}
