/*
 Программы для книги Белова Александра
 Программа 8.1    Глава 8
 Бегущие огни
 
 Схема:
 * Восемь цепочек из последовательного соединенного резистора 270 Ом и светодиода
 * Подключаются между пинами от 2 до 9 и цепью +5 В
 */

const int buttonPin = 13;   // номер контакта для подключения кнопки
const int LoopTime = 200;   // Значение времени задержки шага бегущего огня

void setup() {
  // Цикл инициализации пинов для подключения светодиодов:
  for (int thisPin = 2; thisPin < 10; thisPin++) {
    pinMode(thisPin, OUTPUT);
    digitalWrite(thisPin, HIGH);
  }
  // Инициализация пина подключения кнопки:
  pinMode(buttonPin, INPUT);
}

void loop() {
  if (digitalRead(buttonPin)==HIGH) {
    // Цикл одного пробега бегущего огня в прямом направлении:
    for (int thisPin = 2; thisPin < 10; thisPin++) {
      // Включение текущего светодиода:
      digitalWrite(thisPin, LOW);
      delay(LoopTime);  // Задержка
      // Выключение текущего светодиода:
      digitalWrite(thisPin, HIGH);
    }
  }
  else {
    // Цикл одного пробега бегущего огня в обратном направлении:
    for (int thisPin = 9; thisPin > 1; thisPin--) {
      digitalWrite(thisPin, LOW);
      delay(LoopTime);  // Задержка
      digitalWrite(thisPin, HIGH);
    }
  }
}
