/*
 Программы для книги Белова Александра
 Программа 10.2.    Глава 10
 Бегущие огни. использование прерываний по таймеру 0 (минимум вмешательства в настройки Ардуино)
 
 Схема:
 * Восемь цепочек из последовательного соединенного резистора 270 Ом и светодиода
 * Подключаются между пинами от 2 до 9 и цепью +5 В
 */

const int buttonPin = 13;     // номер контакта для подключения кнопки
const int LoopTime  = 200;  // Значение времени задержки шага бегущего огня
const int loopStart = 2;    // Начало цикла бега
const int loopStop  = 9;    // Конец цикла бега

volatile int TimeCore = 0; // Счетчик таймера 
volatile int thisPin; // Текущий разряд светодиодов

void setup() {
  // Цикл инициализации пинов для подключения светодиодов:
  for (int thisPin = 2; thisPin < 10; thisPin++) {
    pinMode(thisPin, OUTPUT);
    digitalWrite(thisPin, HIGH);
  }
  // Инициализация пина подключения кнопки:
  pinMode(buttonPin, INPUT);
  // Инициализация режима сравнения таймера 0 и привязка к нему прерывания
  OCR0A = 0xA0;            // Устанавливаем значение для сравнения в регистр сравнения A таймера 0
  TIMSK0 |= (1 << OCIE0A); // Разрешение прерывания по регистру сравнения
}

void loop() {
  // Основной цикл остается свободным
  // Сюда вы можете поместить основную программу
  // на фоне которой будет выполняться программа бегущих огней
}


// обработчик прерывания 
SIGNAL(TIMER0_COMPA_vect) {
  TimeCore++;
  if (TimeCore>LoopTime) {
    TimeCore=0;
    digitalWrite(thisPin, HIGH);   // Выключение текущего светодиода
    if (digitalRead(buttonPin)==HIGH) {
      // Цикл одного шага бегущего огня в прямом направлении:
      thisPin++;
      if (thisPin > loopStop) thisPin = loopStart;
      digitalWrite(thisPin, LOW);    // Включение следующего светодиода
    }
    else {
      // Цикл одного шага бегущего огня в обратном направлении:
      thisPin--;
      if (thisPin < loopStart) thisPin = loopStop;
      digitalWrite(thisPin, LOW);    // Включение следующего светодиода
    }
  }
}


