/*
 Программы для книги Белова Александра
 Программа 12.1.    Глава 12
 Ввод и индикация аналогового сигнала
 
 Схема:
 * Восемь цепочек из последовательного соединенного резистора 270 Ом и светодиода
 * Подключаются между пинами от 2 до 9 и цепью +5 В
 * Переменный резистор 10 кОм подключается как потенциометр. 
 * Крайние выводы на +5В и общий провод
 * Движок потенциометра на аналоговый вход A1.
 */

const int analogPin = A0;   // Номер аналогового входа
const int StepVol = 128;    // Шаг разрешения индикатора
const int loopStart = 2;    // Начало цикла бега
const int loopStop  = 9;    // Конец цикла бега

int thisPin; // Текущий разряд светодиодов

void setup() {
  // Цикл инициализации пинов для подключения светодиодов:
  for (thisPin = loopStart; thisPin <= loopStop; thisPin++) {
    pinMode(thisPin, OUTPUT);
    digitalWrite(thisPin, HIGH);
  }
}

void loop() {
  int iVol = 0;
  int AnalogVol = analogRead(analogPin);
  for (thisPin = loopStart; thisPin <= loopStop; thisPin++) {
    if (iVol<AnalogVol) digitalWrite(thisPin,LOW);
    else digitalWrite(thisPin,HIGH);
    iVol += StepVol;
  }
}



