/*
 Программы для книги Белова Александра
 Программа 13.2.    Глава 13
 Ввод и вывод аналогового сигнала Плавная индикация
 
 Схема:
 * Шесть цепочек из последовательного соединенного резистора 270 Ом и светодиода
 * Подключаются между пинами 3,5,6,9,10,11 и цепью +5 В
 * Переменный резистор 10 кОм подключается как потенциометр. 
 * Крайние выводы на +5В и общий провод
 * Движок потенциометра на аналоговый вход A0.
 */

const int analogPin = A0;   // Номер аналогового входа
const int StepVol = 42;    // Шаг разрешения индикатора

const int AnalogPin[] = {3,5,6,9,10,11};  // Номера аналоговых выходов

int thisPin; // Текущий разряд светодиодов

void setup() {
}

void loop() {
  int AnalogVol = analogRead(analogPin)/2;
  for (thisPin = 0; thisPin < 6; thisPin++) {
    analogWrite(AnalogPin[thisPin],rangeVol(AnalogVol+StepVol*thisPin));
  }
}

int rangeVol (int InpVol) {
  int OutpVol = InpVol - 256;
  if (OutpVol>255) OutpVol= 255;
  if (OutpVol<0) OutpVol= 0;
  return 255 - OutpVol;
}

